import math

from algorithm.pla.perceptron import Perceptron


def evaluate(iterations: int, amount_of_values: int, correct_data: list, incorrect_data: list, perceptron: Perceptron):
    cnt_true_pos = 0
    cnt_true_neg = 0
    cnt_false_pos = 0
    cnt_false_neg = 0
    unclassified = 0
    for i in range(500):
        corr = []
        incorr = []
        for j in range(amount_of_values):
            corr.append(correct_data[j][i])
            incorr.append(incorrect_data[j][i])
        jog_res = perceptron.classify(corr)
        knie_res = perceptron.classify(incorr)
        if math.isclose(1, jog_res, abs_tol=0.1):
            cnt_true_pos += 1
        elif math.isclose(0, jog_res, abs_tol=0.1):
            cnt_false_neg += 1
        else:
            unclassified += 1
        if math.isclose(0, knie_res, abs_tol=0.1):
            cnt_true_neg += 1
        elif math.isclose(1, knie_res, abs_tol=0.1):
            cnt_false_pos += 1
        else:
            unclassified += 1
    print(f"""
    Anzahl Prüfungen: {iterations*2}
    True Positive: {cnt_true_pos}
    False Positive: {cnt_false_pos}
    True Negative: {cnt_true_neg}
    False Negative: {cnt_false_neg}
    Unclassifiable: {unclassified}
    Fehlerrate: {(cnt_false_neg+cnt_false_pos) / 10}% bzw. {(cnt_false_neg+cnt_false_pos+unclassified) / 10}%
    """)